#!/usr/bin/perl
# This takes a sam file and collects transcripts by exons and assumes the 3' end is true
#if you provide a fasta file it will us that to produce model transcripts
#please provide a prefix so the outputs can be uniquely named
#
# classify_transcripts_and_polya_segmented.pl prefix polya/TSS_window splice_window polya_min nanopolish_polya.txt input.sam genome.fasta 1 100
# 1 is the minimum copy number and 100 is the top number of abundant gff files to report in gff top 100 file
# the polya window also means the start window for determining the transcription start
# if you dont have a poly a table from nanopolish then set the polya_min to -1 and use no_polya instead of the nanopolish_polya.txt file
# if you set a min polya as 20 for example then it will skip all entries that dont have that minimum poly a length (or the QC was not PASS in the polyA text file)

$gff_top = 100;
$gff_min = 1;

$max_del = 10; # this sets the maximum deletion you are prepared to accept is a nanopore failure

$prefix = $ARGV[0];
$command_line = join ("   ", @ARGV);
$pawindow =  $ARGV[1];
$sadwindow = $ARGV[2];
$pa_min = $ARGV[3];

open(INFILE, "$ARGV[5]"); # opens samfile
open(INFASTA, "$ARGV[6]"); #open fasta

#($gff, $gff_min) = split (/'_'/, $ARGV[3]);
#($gff, $gff_top) = split (/'_'/, $ARGV[4]);
#print "$gff_min xxx $gff_top yyy\n";
$gff_min = $ARGV[7];
$gff_top = $ARGV[8];

if ($gff_min < 1) {$gff_min = 1;}
if ($gff_top < 1) {$gff_top = 100;}


%for_translation = (TTT=>"F", TTC=>"F", TCT=>"S", TCC=>"S", TAT=>"Y", TAC=>"Y", TGT=>"C", TGC=>"C", TTA=>"L", TCA=>"S", TAA=>"*", TGA=>"*", TTG=>"L", TCG=>"S", TAG=>"*", TGG=>"W", CTT=>"L", CTC=>"L", CCT=>"P", CCC=>"P", CAT=>"H", CAC=>"H", CGT=>"R", CGC=>"R", CTA=>"L", CTG=>"L", CCA=>"P", CCG=>"P", CAA=>"Q", CAG=>"Q", CGA=>"R", CGG=>"R", ATT=>"I", ATC=>"I", ACT=>"T", ACC=>"T", AAT=>"N", AAC=>"N", AGT=>"S", AGC=>"S", ATA=>"I", ACA=>"T", AAA=>"K", AGA=>"R", ATG=>"M", ACG=>"T", AAG=>"K", AGG=>"R", GTT=>"V", GTC=>"V", GCT=>"A", GCC=>"A", GAT=>"D", GAC=>"D", GGT=>"G", GGC=>"G", GTA=>"V", GTG=>"V", GCA=>"A", GCG=>"A", GAA=>"E", GAG=>"E", GGA=>"G", GGG=>"G");
%rev_translation = (GGC=>"A", ACT=>"S", TCA=>"*", ACA=>"C", TCG=>"R", GAT=>"I", GTT=>"N", GCT=>"S", GTA=>"Y", TGT=>"T", CGA=>"S", CGG=>"P", CAG=>"L", TGC=>"A", CAC=>"V", CTT=>"K", AAC=>"V", GTG=>"H", TCT=>"R", GGT=>"T", TGG=>"P", CCA=>"W", GAG=>"L", GCG=>"R", CAA=>"L", TTA=>"*", CTG=>"Q", CGT=>"T", CAT=>"M", TTT=>"K", TAC=>"V", CTA=>"*", AAG=>"L", TCC=>"G", GAC=>"V", GCA=>"C", TGA=>"S", AAT=>"I", ATA=>"Y", ATT=>"N", AGT=>"T", TTG=>"Q", GTC=>"D", ACC=>"G", GGA=>"S", AAA=>"F", CCT=>"R", ACG=>"R", CCG=>"R", ATG=>"H", TAT=>"I", GGG=>"P", CCC=>"G", TAA=>"L", CTC=>"E", TAG=>"L", ATC=>"D", AGA=>"S", GAA=>"F", CGC=>"A", GCC=>"G", AGC=>"A", TTC=>"E", AGG=>"P");
%base_pair = (G=>"A", A=>"T", T=>"A", C=>"G");
print "hi\n";
%fasta_file = ();
$fasta_out ="";
$fasta_header = "Not_started_yet";
%polyalen = ();

if ($ARGV[4] ne "no_polya"){
open(INPA, "$ARGV[4]"); #opens nanopolish polya analysis output

while ($line = <INPA>)
{
    chomp $line;
    @pa_cells = split(/\t/, $line);
    if (($pa_cells[8] > $pa_min) and ($pa_cells[9] eq "PASS")) {$polyalen{$pa_cells[0]} = $pa_cells[8];
       # {print "$line\n";}
    } else {$polyalen{$pa_cells[0]} = -1;}
    # if ($pa_cells[0] eq "9d8ff3e9-416d-466a-965e-498f9ef3d185") {print "$line\n";}
}
}

while ($fasta_line = <INFASTA>)
{
    chomp $fasta_line;
    #print "\n$fasta_line\n";
    if (substr($fasta_line,0,1) eq ">") {
        substr($fasta_line,0,1) = "";
        if ($fasta_header ne "Not_started_yet") {
            $fasta_file{$fasta_header} = $fasta_out;
            
            print "\n\n$fasta_header\n\n";
        }
        
        
        ($fasta_header, $tmp) = split (/\s/, $fasta_line, 2);
        
        
        $fasta_out ="";
    }
    else {$fasta_out = uc($fasta_out.$fasta_line);}
}

$fasta_file{$fasta_header} = $fasta_out;
#print "\n\n$fasta_header\n\n";
if ($fasta_header eq "Not_started_yet") {print "wrong command line\n";exit;}
%raw_polya_plus = ();
%raw_start_plus = ();
%raw_sad_plus = ();
%raw_polya_minus = ();
%raw_start_minus = ();
%raw_sad_minus = ();
%raw_soft_five_plus = ();
%raw_soft_three_plus = ();
%raw_soft_five_minus = ();
%raw_soft_three_minus = ();
%raw_soft_five_plus_total = ();
%raw_soft_three_plus_total = ();
%raw_soft_five_minus_total = ();
%raw_soft_three_minus_total = ();

%trans_intron = ();

%sam_file = ();
$total_entries = 0;
%contigs = ();
%feature_loc = (); #unified feature list
open (TABLECOMB, ">$prefix.raw_processed_start_sad_polya.txt");
print TABLECOMB "Contig\tNucleotide\tStart plus\tStart minus\tIntron exon boundary plus\tIntron exon boundary minus\tPolya plus\tPolya minus\tRaw Start plus\tRaw Start minus\tRaw Intron exon boundary plus\tRaw Intron exon boundary minus\tRaw Polya plus\tRaw Polya minus\tCommand line arguments were $command_line\n";
open (TABLESOFT, ">$prefix.raw_soft_clip_locations.txt");
print TABLESOFT "Contig\tNucleotide\tSoft clip five plus\tSoft clip five minus\tSoft clip three plus\tSoft clip three minus\tAverage soft clip five plus\tModal soft clip five plus\tAverage soft clip five minus\tModal soft clip five minus\tAverage soft clip three plus\tModal soft clip three plus\tAverage soft clip three minus\tModal soft clip three minus\n";
open (GFFS, ">$prefix.GFF_all_found.gff3");
   print GFFS "##gff-version 3\n";
       open (GFFTON, ">$prefix.GFF_most_popular_list.gff3");
       print GFFTON "##gff-version 3\n";
   open (TABLENEW, ">$prefix.start_sad_stop_pattern_count.txt");
   print TABLENEW "Contig\tStrand\tStart\tExons\tPolyA site End\tCount\tTranscript name\tAverage poly_A length\tStd deviation\n";
open (GFFFASTA, ">$prefix.canonical_transcripts_by_abundance.fasta");
do
{
    $line = <INFILE>;
    chomp $line;
    $test = substr($line,0,1);
} until ($test ne "@");
#
$test = "start";
$sam_count = 1;
open (TEMP, ">$sam_count.temp_sam.sam");
while ($line_p = <INFILE>)
{
chomp $line_p;
@samcells_p = split(/\t/, $line_p);
$contig_t = $samcells_p[2];
    if ($contig_t eq "*") {next;}
    if ($test eq "start") {$test = $contig_t;}
    if ($test eq $contig_t) {print TEMP "$line_p\n"; next;}
    
    close TEMP;
    close INFILEB;
    print "about to run main sub\n";
    $test = $contig_t;
      
    &main;
    print "did one contig\n";
    close TEMP;
    $sam_count ++;
    #end of main routine
    open (TEMP, ">$sam_count.temp_sam.sam");
    print TEMP "$line_p\n";
    
}
print "running final main sub\n";
close TEMP;
close INFILEB;
&main;

#
#
#
#
#

exit;
#----------------------------------------------------------------------------
sub main{
    %raw_polya_plus = ();
    %raw_start_plus = ();
    %raw_sad_plus = ();
    %raw_polya_minus = ();
    %raw_start_minus = ();
    %raw_sad_minus = ();
    %raw_soft_five_plus = ();
    %raw_soft_three_plus = ();
    %raw_soft_five_minus = ();
    %raw_soft_three_minus = ();
    %raw_soft_five_plus_total = ();
    %raw_soft_three_plus_total = ();
    %raw_soft_five_minus_total = ();
    %raw_soft_three_minus_total = ();
    %contigs = ();
    %trans_intron = ();
    %feature_loc = ();
            close TEMP;
            open(INFILEB, "$sam_count.temp_sam.sam"); # opens samfile

    #Start going through the sam file to find the starts and ends of positive and negative mapped transcripts
    while($line = <INFILEB>)
    {
        #print "$line";
        chomp $line;
        if (substr($line,0,1) eq "@") {$sam_head = $sam_head."$line\n"; next;}
        @samcells = split(/\t/, $line);
        $contig = $samcells[2];
        #print "$fasta_file{$contig} XXXXXXX\n";
        $contigs{$contig} ++;
        $transcriptname = $samcells[0];
        if ($pa_min > -1) {
            if ($polyalen{$transcriptname} < $pa_min){next;}
        }
        #else {$polyalen{$transcriptname} = -1;}
        if ($polyalen{$transcriptname} > 0) {$transcript_name = $transcriptname."\t".$polyalen{$transcriptname};} else {$transcript_name = $transcriptname;}
        
        
        
        $total_entries ++;
        if (($total_entries % 100000) == 0) {print "Entries is $total_entries\n";}
        $flag = $samcells[1];
        if ($flag & 2048) {$sam_file_sup{$transcript_name} = $line; print TEMP "$line\n"; next;}
        $position = $samcells[3];
        $sam_mapq = $samcells[4];
        $sam_transcript = $samcells[9];
        $sam_file{$transcript_name} = $line;
        @cigar = split(/(M|I|D|N|S|H|P|X|=)/, $samcells[5]);
        $trans_ident = "";
        if ($flag & 16) {$loc_ident = "-"."\t".$contig."\t";} else {$loc_ident = "+"."\t".$contig."\t";}
        $intron_len = 0;
        $intron_count = 0;
        $this_exon = 0;
        $exon_len = 0;
        $array_cigar = 1;
        while (length($cigar[$array_cigar]) >=1){
            # THIS IS A MESS!!!
            if ($cigar[$array_cigar] =~ /[S]/){
               
                if ($flag & 16) {
                    if ($array_cigar == 1) {$raw_soft_three_minus{$position} ++; $raw_soft_three_minus_total{$position}=$raw_soft_three_minus_total{$position}."\t".$cigar[$array_cigar - 1];}
                    if ($array_cigar > 1) {$raw_soft_five_minus{$position} ++; $raw_soft_five_minus_total{$position}=$raw_soft_five_minus_total{$position}."\t".$cigar[$array_cigar - 1];}
                } else {
                    if ($array_cigar == 1) {$raw_soft_five_plus{$position} ++; $raw_soft_five_plus_total{$position}=$raw_soft_five_plus_total{$position}."\t".$cigar[$array_cigar - 1];}
                    if ($array_cigar > 1) {$raw_soft_three_plus{$position} ++; $raw_soft_three_plus_total{$position}=$raw_soft_three_plus_total{$position}."\t".$cigar[$array_cigar - 1];}
                }
            }
            if ($cigar[$array_cigar] =~ /[D]/){
                if ($cigar[$array_cigar - 1] > $max_del) {$cigar[$array_cigar] = "N";}
            }
            if ($cigar[$array_cigar] =~ /[MD]/){
                # $intron_len =  $intron_len + $cigar[$array_cigar - 1];
                $position =  $position + $cigar[$array_cigar - 1];
            
            }
            if ($cigar[$array_cigar] =~ /[N]/){
                $position --;
                if ($flag & 16){$raw_sad_minus{$position} ++;} else {$raw_sad_plus{$position} ++;}
                $temp = $loc_ident."sad\t$position";
                $feature_loc{$temp} ++;
                $trans_ident = $trans_ident.$position."\t";
                $position ++;
                $position =  $position + $cigar[$array_cigar - 1];
              
                $intron_count =  $intron_count ++;
                $trans_ident = $trans_ident.$position."\t";
                $temp = $loc_ident."sad\t$position";
                if ($flag & 16){$raw_sad_minus{$position} ++;} else {$raw_sad_plus{$position} ++;}
                $feature_loc{$temp} ++;
                
            }
            
            
            $array_cigar = $array_cigar + 2;
            
        }
        if ($flag & 16){
            $raw_polya_minus{$samcells[3]} ++;
            $raw_start_minus{$position} ++;
            $temp = $loc_ident."start\t$position";
            $feature_loc{$temp} ++;
            $temp = $loc_ident."end\t$samcells[3]";
            $feature_loc{$temp} ++;
            $trans_intron{$transcript_name} = "$contig\t-\t$position\t".$trans_ident."$samcells[3]";
       
        } else {
            $raw_polya_plus{$position} ++;
            $raw_start_plus{$samcells[3]} ++;
            $temp = $loc_ident."start\t$samcells[3]";
            $feature_loc{$temp} ++;
            $temp = $loc_ident."end\t$position";
            $feature_loc{$temp} ++;
            $trans_intron{$transcript_name} = "$contig\t+\t$samcells[3]\t".$trans_ident."$position";
            #@array = split (/\t/, $trans_intron{$transcript_name});
            #if (scalar(@array) <5){print "$transcript_name xxx $trans_intron{$transcript_name}\n$line\n\n";}
        }
        #if (index ($transcript_name, "1e4cba4d-fcc8-4d33-b7bf-8f8642bb3630") == 0){print "AAA\n$trans_intron{$transcript_name}\n$transcript_name\nBBBBB\n";}
        #if ($transcriptname eq "9d8ff3e9-416d-466a-965e-498f9ef3d185") {print "$trans_intron{$transcript_name}\n$transcript_name\n";}
    }




    print "Found all features, there are $total_entries processed sam lines\n";
    $command_line = $command_line." there are $total_entries processed lines";
    # Now to find the most popular features
    %raw_features = %feature_loc;
        @popular_feature = ();
        %pop_feature = ();
        $feature_count = scalar (keys %feature_loc);
    print "Start feature count $feature_count\n";
    $tmp_report = 0;
    @feature_pos = sort { $feature_loc{$a} <=> $feature_loc{$b} } keys %feature_loc;
        while (keys %feature_loc > 0) {
        
        $most_feature_pos = pop @feature_pos; #now we have the most popular feature
            if (exists $feature_loc{$most_feature_pos}) {
                $pop_feature{$most_feature_pos} = $feature_loc{$most_feature_pos};} else {next;}
            $popular_feature[$feature_count] = $most_feature_pos;
            delete $feature_loc{$most_feature_pos};
            $feature_count --;
            
            ($m_strand,$m_contig,$m_type, $m_position) = split (/\t/, $most_feature_pos);
            foreach $key (keys %feature_loc){
            ($strand,$contig,$type, $position) = split (/\t/, $key);
                if ($type ne $m_type) {next;}
                if ($type eq "sad") {$window = $sadwindow;} else {$window = $pawindow;}
                if ($position > ($m_position + $window)){next;}
                if ($position < ($m_position - $window)){next;}
                if ($strand ne $m_strand) {next;}
                if ($contig ne $m_contig) {next;}
                
                
                #if ($position < ($m_position + $window) and $position > ($m_position - $window)){
               
                    $pop_feature{$most_feature_pos} = $pop_feature{$most_feature_pos} + $feature_loc{$key};
                   delete $feature_loc{$key}; $feature_count --;
                # if ($feature_count % 1000 == 0) {print "Feature $feature_count\n";}
                
            }
            
            
            
        }


    # All the most popular features have now been found and put into a hash.
    # now we can look again at the trans_intron hash and compare it to the popular features hash

    #remember the NS in this context means that the transcripts were not characterised using the mapped start site, onnly the poly a and exon boundaries


    $feature_count = scalar (keys %pop_feature);
    print "Most popular features counted are $feature_count\n";
  


    %temp_polya_add = ();

    %plus_sad = (); #plus stran splice accepto donor locations
    %minus_sad = ();
    %plus_start = (); #plus strand transcription start sites
    %minus_start = ();
    %plus_polya = (); #plus strand poly a sites
    %minus_polya= ();
    #Combined table stuff
    $comb_nucleotide = 0;

    #
    foreach $contig_name (keys %contigs){
        %temp = ();
        
        %temp_count = ();
        %temp_long = ();
        $tmpreport_count = 0;
        
        foreach $key (keys %trans_intron){
            #if (index ($key, "1e4cba4d-fcc8-4d33-b7bf-8f8642bb3630") == 0){print "$trans_intron{$key} aaxxyy \n";}
            @array = split (/\t/, $trans_intron{$key});
            #if (scalar(@array) <5){print "$key xxx $trans_intron {$key}\n";}
            $this_contig = shift @array;
            
            if ($this_contig ne $contig_name) {next;}
            $strand = $array[0];
            if ($array [-1] == 30820) {$tmpreport_count ++;}
            $joined = join ("\t", @array);
            $temp{$key} = $joined;
        }
        
        foreach $key (keys %pop_feature){
           
            ($strand,$contig,$type, $position) = split (/\t/, $key);
            if ($contig ne $contig_name) {next;}
            $value = $pop_feature{$key};
            #print "$key  is $value\n";
            if ($strand eq "+") {
                if ($type eq "sad") {$plus_sad {$position} = $value; }
                if ($type eq "start") {$plus_start {$position} = $value;}
                if ($type eq "end") {$plus_polya {$position} = $value;}
            } else {
                if ($type eq "sad") {$minus_sad {$position} = $value;}
                if ($type eq "start") {$minus_start {$position} = $value;}
                if ($type eq "end") {$minus_polya {$position} = $value;}
            }
    }
        #foreach $key (sort { $a <=> $b } keys(%plus_sad) ){ print  TABLE "$contig_name\t$key\t$plus_sad{$key}\n";}
        #foreach $key (sort { $a <=> $b } keys(%minus_sad) ){ print TABLE "$contig_name\t$key\t$minus_sad{$key}\n";}
        #foreach $key (sort { $a <=> $b } keys(%plus_start) ){ print TABLEST "$contig_name\t$key\t$plus_start{$key}\n";}
        #foreach $key (sort { $a <=> $b } keys(%minus_start) ){ print TABLEST "$contig_name\t$key\t$minus_start{$key}\n";}
        #foreach $key (sort { $a <=> $b } keys(%plus_polya) ){ print TABLEPA "$contig_name\t$key\t$plus_polya{$key}\n";}
        #foreach $key (sort { $a <=> $b } keys(%minus_polya) ){ print TABLEPA "$contig_name\t$key\t$minus_polya{$key}\n";}
        
        %tplus_sad = %plus_sad; #plus stran splice accepto donor locations
        %tminus_sad = %minus_sad;
        %tplus_start = %plus_start; #plus strand transcription start sites
        %tminus_start = %minus_start ;
        %tplus_polya = %plus_polya; #plus strand poly a sites
        %tminus_polya= %minus_polya;
        
        $combined_stop = "go";
        do {
            $comb_nucleotide ++;
            #print "$comb_nucleotide   ";
            $tmp_nucleotide = " ";
            if (exists $fasta_file{$contig_name}){
                $tmp_nucleotide = substr($fasta_file{$contig_name},($comb_nucleotide - 1),1)
            }
            print TABLECOMB "$contig_name\t$comb_nucleotide"."_"."$tmp_nucleotide\t$plus_start{$comb_nucleotide}\t$minus_start{$comb_nucleotide}\t$plus_sad{$comb_nucleotide}\t$minus_sad{$comb_nucleotide}\t$plus_polya{$comb_nucleotide}\t$minus_polya{$comb_nucleotide}\t$raw_start_plus{$comb_nucleotide}\t$raw_start_minus{$comb_nucleotide}\t$raw_sad_plus{$comb_nucleotide}\t$raw_sad_minus{$comb_nucleotide}\t$raw_polya_plus{$comb_nucleotide}\t$raw_polya_minus{$comb_nucleotide}\n";
            $average_rsfp = 0;$std_rsfp = 0;
            $average_rstp = 0;$std_rstp = 0;
            $average_rsfm = 0;$std_rsfm = 0;
            $average_rstm = 0;$std_rstm = 0;
            if (exists $raw_soft_five_plus{$comb_nucleotide}) {@arraypa = split (/\t/, $raw_soft_five_plus_total{$comb_nucleotide});$tmp_a = shift @arraypa; $total = (scalar @arraypa); $average_rsfp = int( &average (@arraypa));$std_rsfp = &mode (@arraypa);
                #print "AAA $mode\n$std_rsfp\n";
            }
            if (exists $raw_soft_three_plus{$comb_nucleotide}) {@arraypa = split (/\t/, $raw_soft_three_plus_total{$comb_nucleotide}); $tmp_a = shift @arraypa; $total = (scalar @arraypa); $average_rstp =int( &average (@arraypa));$std_rstp = &mode (@arraypa);
                #if (($total < 100) and ($std_rstp < 1)){print TABLESOFT "$raw_soft_three_plus_total{$comb_nucleotide}\n";}
            }
            if (exists $raw_soft_five_minus{$comb_nucleotide}) {@arraypa = split (/\t/, $raw_soft_five_minus_total{$comb_nucleotide}); $tmp_a = shift @arraypa; $total = (scalar @arraypa); $average_rsfm =int( &average (@arraypa));$std_rsfm = &mode (@arraypa);}
            if (exists $raw_soft_three_minus{$comb_nucleotide}) {@arraypa = split (/\t/, $raw_soft_three_minus_total{$comb_nucleotide}); $tmp_a = shift @arraypa; $total = (scalar @arraypa); $average_rstm =int (&average (@arraypa));$std_rstm = &mode (@arraypa);}
            #if (exists $raw_soft_three_plus{$comb_nucleotide}) {$average_rstp = $raw_soft_three_plus_total{$comb_nucleotide}/$raw_soft_three_plus{$comb_nucleotide};}
            #if (exists $raw_soft_five_minus{$comb_nucleotide}) {$average_rsfm = $raw_soft_five_minus_total{$comb_nucleotide}/$raw_soft_five_minus{$comb_nucleotide};}
            #if (exists $raw_soft_three_minus{$comb_nucleotide}) {$average_rstm = $raw_soft_three_minus_total{$comb_nucleotide}/$raw_soft_three_minus{$comb_nucleotide};}
            
            print TABLESOFT "$contig_name\t$comb_nucleotide"."_"."$tmp_nucleotide\t$raw_soft_five_plus{$comb_nucleotide}\t$raw_soft_five_minus{$comb_nucleotide}\t$raw_soft_three_plus{$comb_nucleotide}\t$raw_soft_three_minus{$comb_nucleotide}\t$average_rsfp\t$std_rsfp\t$average_rsfm\t$std_rsfm\t$average_rstp\t$std_rstp\t$average_rstm\t$std_rstm\n";
            
            
            delete $raw_start_plus{$comb_nucleotide};
            delete $raw_start_minus{$comb_nucleotide};
            delete $raw_sad_plus{$comb_nucleotide};
            delete $raw_sad_minus{$comb_nucleotide};
            delete $raw_polya_plus{$comb_nucleotide};
            delete $raw_polya_minus{$comb_nucleotide};
            if (((keys %raw_start_plus) == 0) and ((keys %raw_start_minus) == 0) and ((keys %raw_sad_plus) == 0) and ((keys %raw_sad_minus) == 0) and ((keys %raw_polya_plus) == 0) and ((keys %raw_polya_minus) == 0)) {$combined_stop = "stop raw";}
      
            delete $tplus_start{$comb_nucleotide};
            delete $tminus_start{$comb_nucleotide};
            delete $tplus_sad{$comb_nucleotide};
            delete $tminus_sad{$comb_nucleotide};
            delete $tplus_polya{$comb_nucleotide};
            delete $tminus_polya{$comb_nucleotide};
            if (((keys %tplus_start) == 0) and ((keys %tminus_start) == 0) and ((keys %tplus_sad) == 0) and ((keys %tminus_sad) == 0) and ((keys %tplus_polya) == 0) and ((keys %tminus_polya) == 0) and ($combined_stop eq "stop raw")) {$combined_stop = "stop";}
        } until ($combined_stop eq "stop");
        #close TABLECOMB;
        print "Produced the features table\n";
        $tmpreport_count = 0;
        $tmpreport_count_b =0;
         $tmpreport_count_c =0;
        foreach $transcript_name (keys %temp){
            @array =split (/\t/, $temp{$transcript_name});
          
            $strand = shift @array;
            $start = shift @array;
            $end = pop @array;
            $tmp_end = $end;
            $tmp_start = $start;
            #print "$transcript_name\n@array\n";
            $array_count = 0;
            $window = $pawindow;
            %temp_polya = %plus_polya; %temp_start = %plus_start; %temp_sad = %plus_sad;
            # here we take actual ends polys and splice acceptor donors and check to see f they are near popular ones and then change the values
            if ($strand eq "-") {%temp_polya = %minus_polya; %temp_start = %minus_start; %temp_sad = %minus_sad;}
           
            foreach $pop_end (sort {$temp_polya{$b} <=> $temp_polya{$a} } keys %temp_polya){
                #if (($pop_end > 30810) and ($pop_end < 30830)) {print "$pop_end ... pop end\n";}
                $win_a = $pop_end - $window; $win_b = $pop_end + $window;
                if ( ($tmp_end >= $win_a) and ($tmp_end <= $win_b) ){$end = $pop_end; last;}
                
            }
            
            foreach $pop_start (sort {$temp_start{$b} <=> $temp_start{$a} } keys %temp_start){
                if ($tmp_start <= ($pop_start + $window) and $tmp_start >= ($pop_start - $window)){$start = $pop_start;last;}
            }
            #print "set window to splice acceptor donor window\n";
            $window = $sadwindow;
            $sclr_arr = scalar(@array);
           do {
               $tmp_array = $array[$array_count];
                foreach $pop_sad (sort {$temp_sad{$b} <=> $temp_sad{$a} } keys %temp_sad){
                    $tmp_top = $pop_sad + $window; $tmp_low = $pop_sad - $window; if ($tmp_low < 0) {$tmp_low = 0;}
                    #print "$tmp_array AA $pop_sad BB $window CC\n";
                    if (($tmp_array < $tmp_top) and ($tmp_array > $tmp_low)){$array[$array_count] = $pop_sad; last;}
                    
                    #print "$array_count  ";
                }
               $array_count ++;
               #print "$array_count  BBBBB $sclr_arr CCCCCC";
           } until ($array_count > $sclr_arr);
            if ((scalar @array) == 0) {$intronless = "yes";} else {$intronless = "no";}
            #print "done the sad windows\n";
            #
            push @array, $end;
            $new_values_tmp = join (' ', @array);
            $new_ns_values = $strand." ".$new_values_tmp;
            unshift @array, $start;
            unshift @array, $strand;
            $new_values = join (' ', @array);
            
            
            $temp_long{$new_values} = $transcript_name;
            @polya_len = split (/\t/, $transcript_name);

            if (scalar @polya_len > 1){
           
            if ($polya_len[1] >= $pa_min){
            if (exists $temp_polya_add{$new_values}) {$temp_polya_add{$new_values} = $temp_polya_add{$new_values}."\t".$polya_len[1];} else {$temp_polya_add{$new_values} = $polya_len[1];}
            }
            
            }
            
            $temp_count{$new_values} ++;
            #print "now here with new values $new_values\n";
            if ($intronless eq "no") {
            # this bit deals with transcripts where we want to rely on internal structures of exona and as such intronless stuff is left out.
            $temp_ns_count{$new_ns_values} ++;
            if (exists $temp_ns_long{$new_ns_values}) {
                $old_tn = $temp_ns_long{$new_ns_values};
                @array_old = split (/\t/, $trans_intron{$old_tn});
                @array_new = split (/\t/, $trans_intron{$transcript_name});
                
                if (($strand eq "+") and ($array_old[2] > $array_new[2])) {$temp_ns_long{$new_ns_values} = $transcript_name;}
                if (($strand eq "-") and ($array_old[2] < $array_new[2])) {$temp_ns_long{$new_ns_values} = $transcript_name;}
                
            } else {$temp_ns_long{$new_ns_values} = $transcript_name;}
            
            }
            
        }
        

    $size = keys %temp_count;
    $max_reads = -123456789;
    $counta = 0;
   print "now here $size\n";
       
        #open (TABLESAMINTRON, ">$prefix.new_count_intronless.sam");
    foreach $key (sort { $temp_count{$b} <=> $temp_count{$a}  } keys(%temp_count) ){
        #print "hello here\n";
        print  "$contig_name\t$key\t$temp_count{$key}\n";
        @array =split (/\s/, $key);
        $counta ++;
        $transcript_name = $temp_long{$key};
        $sam_line = $sam_file{$transcript_name}."\tCO:Z:$temp_count{$key}\n";
        
        @gff = @array;
        $gff_value = $trans_intron{$transcript_name};
        @gff_tmp = split (/\t/, $gff_value);
        @arraypa = split (/\t/, $temp_polya_add{$key});
        $total = scalar @arraypa;
        $av_polya = int (&average (@arraypa));
        $sdev_polya = &stdev (@arraypa);
        
        
        #$gff_contig = shift @gff;
        $gff_contig = $contig_name;
        $gff_strand = shift @gff;
        $gff_value = join (' ', @gff);
        $gff_value = $gff_strand." ".$gff_value;
        $printed_name = "mRNA#".$counta."_".$temp_count{$key}."_copies:polyA_is_".$av_polya;
        #open (VIOLIN, ">$printed_name.violin.txt");
        #print "$gff_value\n";
        if ($gff_strand eq "+"){
            $gff_start = shift @gff;
            $gff_end = pop @gff;
            $gff_end = $gff_end - 1;
            #$_-- for @gff;
            $tmp_values = join (' ', @gff);
            print TABLENEW "$contig_name\t$gff_strand\t$gff_start\t$tmp_values\t$gff_end\t$temp_count{$key}\t$printed_name\t$av_polya\t$sdev_polya\n";
        } else {
            $gff_end = shift @gff;
            $gff_start = pop @gff;
            $gff_start = $gff_start -1;
            #$_++ for @gff;
            $tmp_values = join (' ', @gff);
            print TABLENEW "$contig_name\t$gff_strand\t$gff_end\t$tmp_values\t$gff_start\t$temp_count{$key}\t$printed_name\t$av_polya\t$sdev_polya\n";
        }
        
        $gff_count = $temp_count{$key};
        if ($max_reads == -123456789) {$max_reads = $gff_count;}
        
        
        
        #
        #
        $gff_colorb = $gff_count/$max_reads;
        $gff_color = "190,190,255";
        if ($gff_colorb > 0.10) {$gff_color = "0,255,0";}
        if ($gff_colorb > 0.3) {$gff_color = "255,150,150";}
        if ($gff_colorb > 0.7) {$gff_color = "255,0,0";}
        $gff_id = $printed_name;
        $gff_transcript = "";
        if ($gff_count >0) {print GFFS "$gff_contig\tnanopore\tmRNA\t$gff_start\t$gff_end\t.\t$gff_strand\t.\tID=$gff_id;Count=$gff_count;color=$gff_color\n";}
        if (($counta <= $gff_top) and ($gff_count >= $gff_min)) {print GFFTON "$gff_contig\tnanopore\tmRNA\t$gff_start\t$gff_end\t.\t$gff_strand\t.\tID=$gff_id;Count=$gff_count;color=$gff_color\n";}
        $exons = 1;
        $e_start = $gff_start;
        while (scalar @gff > 0){
            $exon_id = "exon_".$exons;
            $exons ++;
            $e_end = shift @gff;
            if ($gff_count >0) {print GFFS "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id\n";}
            if (($counta <= $gff_top) and ($gff_count >= $gff_min)) {print GFFTON "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id\n";}
            if (exists $fasta_file{$gff_contig}){
               # print "here it does\n";
                $tmp= substr ($fasta_file{$gff_contig}, $e_start, ($e_end - $e_start));
                $gff_transcript = $gff_transcript.$tmp;
            }
            $e_start = shift @gff;
            #$e_start --;
        }
        #$exons ++;
        $exon_id = "exon".$exons;
        $e_end = $gff_end;
        if ($gff_count >0) {print GFFS "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id;Comment=Last_exon\n";}
        if (($counta <= $gff_top) and ($gff_count >= $gff_min)) {print GFFTON "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id;Comment=Last_exon\n";}
       
        if (exists $fasta_file{$gff_contig}){
            $tmp= substr ($fasta_file{$gff_contig}, $e_start, ($e_end - $e_start));
            $gff_transcript = $gff_transcript.$tmp;
            if ($gff_strand eq "-") {
                $tmprev_transcript = reverse($gff_transcript);
                $tmprev_transcript =~ tr/ACGTacgt/TGCAtgca/;
                $gff_transcript = $tmprev_transcript;
            }
            $gff_trans_name = $gff_id." ".$gff_value."\t".$gff_transcript;
            $fasta_outputs{$gff_trans_name} = $gff_count;
            # print "hello $fasta_outputs{$gff_trans_name}  $gff_trans_name\n";
        }
        
        
        
        $fasta_outputs{$gff_trans_name} = $gff_count;
        #print "maybe here?\n";
    }
       print "made it here";
    $count = 0;
        #%fasta_outputs = ();
        #open (GFF, ">$prefix.Grouped_without_start_info_gff.gff3");
    print GFF "##gff-version 3\n";
        #open (TABLENSNEW, ">$prefix.sad_stop_pattern_count.txt");
    print TABLENSNEW "Contig\tStrand\tExons\tPolyA site\tCount\tTranscript name\n";
        #open (TABLENSSAM, ">$prefix.representative_mapped_transcripts_grouped_without_start_info.sam");
        #open (TABLENSSAMINTRON, ">$prefix.grouped_without_start_info_intronless.sam");
        foreach $key (sort { $temp_ns_count{$b} <=> $temp_ns_count{$a} } keys(%temp_ns_count) ){
        $count ++;
        #print TABLENSNEW "$contig_name\t$key\t$temp_ns_count{$key}\n";
        @array =split (/\s/, $key);
        $transcript_name = $temp_ns_long{$key};
        @gff = @array;
        $gff_value = $trans_intron{$transcript_name};
        @gff_tmp = split (/\t/, $gff_value);
      
        
        #$gff_contig = shift @gff;
        $gff_contig = $contig_name;
        $gff_strand = shift @gff;
        $gff_value = join (' ', @gff);
        $gff_value = $gff_strand." ".$gff_tmp[2]." ".$gff_value;
            #print "$gff_value\n";
        if ($gff_strand eq "+"){
        $gff_start = $gff_tmp[2];
        $gff_end = pop @gff;
        $gff_end = $gff_end;
        $tmp_values = join (' ', @gff);
        print TABLENSNEW "$contig_name\t$gff_strand\t$tmp_values\t$gff_end\t$temp_ns_count{$key}\tmrna$count\n";
        } else {
            $gff_end = $gff_tmp[2];
            $gff_start = pop @gff;
            $gff_start = $gff_start;
            $tmp_values = join (' ', @gff);
            print TABLENSNEW "$contig_name\t$gff_strand\t$tmp_values\t$gff_start\t$temp_ns_count{$key}\tmrna$count\n";
        }
        $gff_id = "mrna".$count.";";
        $gff_count = $temp_ns_count{$key};
        
        #
        #
       
        $gff_transcript = "";
        if ($gff_count >0) {print GFF "$gff_contig\tnanopore\tmRNA\t$gff_start\t$gff_end\t.\t$gff_strand\t.\tID=$gff_id;Count=$gff_count\n";}
        $exons = 0;
        $e_start = $gff_start;
        while (scalar @gff > 0){
            $exon_id = "exon".$exons;
            $exons ++;
            $e_end = shift @gff;
            if ($gff_count >0) {print GFF "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id\n";}
            if (exists $fasta_file{$gff_contig}){
                $tmp= substr ($fasta_file{$gff_contig}, $e_start, ($e_end - $e_start));
                $gff_transcript = $gff_transcript.$tmp;
            }
            $e_start = shift @gff;
        }
        $exons ++;
        $exon_id = "exon".$exons;
        $e_end = $gff_end;
        if ($gff_count >0) {print GFF "$gff_contig\tnanopore\texon\t$e_start\t$e_end\t.\t$gff_strand\t.\tID=$exon_id;Parent=$gff_id;Comment=last\n";}
        if (exists $fasta_file{$gff_contig}){
            $tmp= substr ($fasta_file{$gff_contig}, $e_start, ($e_end - $e_start));
            $gff_transcript = $gff_transcript.$tmp;
            $gff_trans_name = $gff_id." ".$gff_value."\t".$gff_transcript;
            #$fasta_outputs{$gff_trans_name} = $gff_count;
        }
        
        
        
        #$fasta_outputs{$gff_trans_name} = $gff_count;
        #
        #
        $transcript_name = $temp_ns_long{$key};
        $sam_line = $sam_file{$transcript_name}."\tCO:Z:$temp_ns_count{$key}\n";
        if ($temp_ns_count{$key} > 10) {
            if ($exons < 2) {print TABLENSSAMINTRON $sam_line;} else
            {print TABLENSSAM $sam_line;}
        }
    }
#print "$gff_contig\n";
    if (exists $fasta_file{$gff_contig}){
    
        foreach $key (sort {$fasta_outputs{$b} <=> $fasta_outputs{$a}} keys %fasta_outputs){
            ($header,$transcript) = split (/\t/,$key);
            #print "$key\n";
            print GFFFASTA ">".$header."\n".$transcript."\n";
        }
    }

    }
        
        return $key;
        }
    
    
    







sub average{
    #my($data) = @_;
    if ($total < 1) {
        $average = -1;
        return $average;
    }
    $total_sum = 0;
    foreach (@arraypa) {
        $total_sum += $_;
    }
    $average = $total_sum / $total;
    $average = int ($average * 100) / 100;
    return $average;
}
sub stdev{
    if ($total < 1) {
        $std = -1;
        return $std;
    }
    #my($data) = @_;
    if(@arraypa == 1){
        return 0;
    }
    $average = &average(@arraypa);
    $sqtotal = 0;
    foreach(@arraypa) {
        $sqtotal += ($average-$_) ** 2;
    }
    $std = ($sqtotal / (@arraypa-1)) ** 0.5;
    $std = int ($std * 100) / 100;
    return $std;
}

sub mode{
    %tmp_mode = ();
    foreach (@arraypa){
        $tmp_mode {$_} ++;
    }
    @mode_tmp = sort { $tmp_mode{$a} <=> $tmp_mode{$b} } keys %tmp_mode;
    $mode = "modal is ".$mode_tmp[-1]." with ".$tmp_mode{$mode_tmp[-1]}." observations";
    #print "$mode\n";
    return $mode;
}
