#!/bin/zsh

# Process: Do the whole process from minimap_W0_Matthews

# cd ~/OneDrive\ -\ Imperial\ College\ London/_Data/RNA-seq-robOnedrive/Nanopore_RNA-seq
# permissions with chmod u+x _Paper_analysis/vs_WTw_output/paper_vs_WTwv2_part2.sh
# run with ./_Paper_analysis/vs_WTw_output/paper_vs_WTwv2_part2.sh


# run script to add W0 exons, but also produces extra files.
# could run script to add column of stars at this point, and then run the original version of Aaron's script
# awk -v OFS='\t'{ print $0, "*" }' infile >newfile

Rscript ./Aaron_script/W0_correcting.r ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.sam ./EBV_annotations/EBV_annotations_paper/EBNAexons_pHB9_oriPMlu.bed
# Move now included in prefix in command above
mv updated_AllvsWTw_unq.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.sam
mv candidates_W0_id.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id.sam
mv candidates_mixed_id.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id.sam
mv candidates_W2_id.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id.sam
mv candidates_unassigned_id.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.sam
# mv candidates_unassigned_id.log _Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.log

samtools view -b _Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.bam
samtools sort ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.bam
samtools view -h ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam
# remove intermediates
rm ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.sam
rm ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.bam

# Make candidate reads available for viewing on IGV - do not need to sort bam file as the Rscript re-sorts the file before outputting them.
samtools view -b ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id.bam
# samtools sort ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W0_id.bam

samtools view -b ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id.bam
#samtools sort ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_W2_id.bam

samtools view -b ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.bam
#samtools sort ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_unassigned_id.bam

samtools view -b ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id.bam
#samtools sort ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_candidates_mixed_id.bam

#Now can run Aaron's full_length_transcript_identification. 


Rscript ./Aaron_script/transcript_classifying.r ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam 2 5 20 20
# for testing if samtools sort screws up the script: Rscript ./Aaron_script/transcript_classifying.r ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_corrected.sam 2 5 20 20


# merge the outputs from Aaron's first script back into a single file, which now has the * column at the end (x_dotcol.sam)

# cat _Paper_analysis/vs_WTw_output/W0_SAM/AllvsWTw_W0_3p_intact_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/AllvsWTw_W0_5p_intact_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/AllvsWTw_W0_full_length_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/AllvsWTw_W0_unassigned_reads.sam > _Paper_analysis/vs_WTw_output/W0_SAM/AllvsWTw_W0_dotcol.sam
# move files - will overwrite files of same name
 mv 3p_intact_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_3p_intact/AllvsWTw_3p_intact_transcripts.sam
 mv 5p_intact_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_5p_intact/AllvsWTw_5p_intact_transcripts.sam
 mv unassigned.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_ends_not_assigned/AllvsWTw_unassigned.sam
 mv full_length_transcripts.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.sam
 #mv ./_Paper_analysis/vs_WTw_output/W0_SAM/*_dotcol.sam ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first


# Process Full length reads from AllvsMR11_W0_full_length_transcripts.sam
# Add back header no longer required
# sed -n '1,6p' ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_head.sam && cat ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_full_length_transcripts.sam >> ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_head.sam

# sort and index Bam and sort SAM
samtools view -b ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.bam
samtools sort ././_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.bam
samtools index ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.bam
samtools view -h ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.bam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.sam
# remove intermediates
rm ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.sam
rm ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_full_length_transcripts.bam





# rerun Aaron's W0 script. Output to _Paper_analysis/vs_WTw_output/W0_SAM/W0_first folder. Probably dont need the new dotcol sam it produces.

#Rscript ./Aaron_script/transcript_variation_calculation.r ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_W0_dotcol.sam _Paper_analysis/vs_WTw_output/W0_SAM/W0_First/AllvsWTw_W0_dotcol ./EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa ./EBV_annotations/EBV_annotations_paper/EBNAexons_pHB9_oriPMlu.bed 5 20 2

# and now run W length variation on the full length reads. Output to W0_SAM/W0_Full_length.
Rscript ./Aaron_script/IR1_repeat_counting.r ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.sam ./EBV_annotations/EBV_annotations_paper/EBNAexons_pHB9_oriPMlu.bed 20 3

mkdir ./_Paper_analysis/vs_WTw_output/IR1_analysis
mv exon_contents.txt _Paper_analysis/vs_WTw_output/IR1_analysis/AllvsWTw_fulllength_exon_contents.txt
mv IR1_repeat_counts.txt _Paper_analysis/vs_WTw_output/IR1_analysis/AllvsWTw_fulllength_IR1_repeat_counts.txt


Rscript ./Aaron_script/IR1_repeat_counting.r ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam ./EBV_annotations/EBV_annotations_paper/EBNAexons_pHB9_oriPMlu.bed 20 3

mv exon_contents.txt _Paper_analysis/vs_WTw_output/IR1_analysis/AllvsWTw_AllReads_exon_contents.txt
mv IR1_repeat_counts.txt _Paper_analysis/vs_WTw_output/IR1_analysis/AllvsWTw__AllReads_IR1_repeat_counts.txt



# probably need to end part 1 here, check size of header (depends on number of prior processes) in _Paper_analysis/vs_WTw_output/SAM_unq/prefix_unq.sam and run part 2 after editing the next line
# In this run where there is only one mapping step and no concatenation, there is only 3 header rows.

# sed -n '1,6p' ./_Paper_analysis/vs_WTw_output/SAM_unq/AllvsWTw_unq.sam > ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_head.sam && cat ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_first/AllvsWTw_W0_dotcol.sam >> ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_head.sam

# sort and index Bam and sort SAM

   # index to link fastq reads to fast5 files for nanopolish. Takes a relatively long time, so don't repeat if possible.
   #[readdb] num reads: 3689846, num reads with path to fast5: 3693
   #fast5 files could not be located for 3686153 reads
  
   # separated FAST5 files based on oriPMlu alignment: coded end of part 1
   # the output from this nanopolish can be used for all the single samples as well.
  
# nanopolish index -d EBV_oriPMlu_Fast5 ./Guppy_6_output/Guppy6_Allpassreads.fastq.gz

# remember needs a bam file input. first test _unq.bam then could test w0_all_reads/ W0_sort.bam just in case read order is important and downstream fastq in SAM is not.
nanopolish polya --threads=8 --reads=Guppy_6_output/Guppy6_Allpassreads.fastq.gz --bam=./_Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.bam --genome=EBV_annotations/EBV_annotations_paper/WTw_oriPMlu.fa > _Paper_analysis/vs_WTw_output/Matthews_script/Nanopolish/AllvsWTw_W0_polya_results.tsv

# Run the Matthews script 1. Amend prefix for correct folder. Have changed fa file to MR11 (and prefix) for forst example into script1 and 2 folders, and second command uses nanopolish from pre-W0 appended file. 
# - guidance:classify_transcripts_and_polya_segmented_V2.pl prefix polya/TSS_window splice_window polya_min nanopolish_polya.txt input.sam genome.fasta splice_tolerance(1) 100
# changed numbers to use: start/pA window +/-20; splice window 2; minpA 8 as there are positionally realistic reads with short pA.
# using an altered version of the MR11 fasta (MR11_noATG) to remove ATGs that are not used or make very small peptides.



perl Matthews_script/classify_transcripts_and_polya_segmented_V2.pl _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_AllReads 20 2 8 _Paper_analysis/vs_WTw_output/Matthews_script/Nanopolish/AllvsWTw_W0_polya_results.tsv _Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa 1 80

#renaming to get rid of the dot in the name - this was not required
# mv _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_AllReads.start_sad_stop_pattern_count.txt > _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_AllReads_start_sad_stop_pattern_count.txt

# Run the Matthews script 2. prefix for does not tolerate folder prefix
# - guidance: And now second script: name_transcripts_and_track_ssc_V2.pl prefix ssc_nt features_table.txt genome.fasta start_sad_stop_pattern_count.txt
perl Matthews_script/name_transcripts_and_track_ssc_V2.pl 2_AllvsWTw_W0_AllReads 10 EBV_annotations/EBV_annotations_paper/Features_table_pHB9_oriPMlu.txt EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_AllReads.start_sad_stop_pattern_count.txt

mv 2_AllvsWTw_W0_AllReads_ssc.proteins_not_known.fasta _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.proteins_not_known.fasta
mv 2_AllvsWTw_W0_AllReads_ssc.proteins_known.fasta _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.proteins_known.fasta
# rm _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc
cp -r 2_AllvsWTw_W0_AllReads_ssc  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/
rm -rf 2_AllvsWTw_W0_AllReads_ssc
mv 2_AllvsWTw_W0_AllReads_ssc.combined_counts_and_feature_names.txt  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.combined_counts_and_feature_names.txt
mv 2_AllvsWTw_W0_AllReads_ssc.count_of_translated_features.txt  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.count_of_translated_features.txt
mv 2_AllvsWTw_W0_AllReads_ssc.most_abundant_trans_per_orf.gff _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.most_abundant_trans_per_orf.gff
mv 2_AllvsWTw_W0_AllReads_ssc.splice_acceptor_donor_usage.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.splice_acceptor_donor_usage.txt
mv 2_AllvsWTw_W0_AllReads_ssc.TSS_start_sad_polyA_count_list.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_AllReads_ssc.TSS_start_sad_polyA_count_list.txt


perl Matthews_script/all_transcripts_grouped_by_polya.pl _Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam 1 100 20 25 40 EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa

mkdir _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/pA_SAM_allreads
mv -f polya_group_* _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/pA_SAM_allreads


# Now re-run the Matthews script 1 for the full length reads only. Amend prefix for correct folder. Have changed fa file to MR11 (and prefix) for forst example into script1 and 2 folders, and second command uses nanopolish from pre-W0 appended file. 
# - guidance:classify_transcripts_and_polya_segmented_V2.pl prefix polya/TSS_window splice_window polya_min nanopolish_polya.txt input.sam genome.fasta splice_tolerance(1) 100

perl Matthews_script/classify_transcripts_and_polya_segmented_V2.pl _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_fullLength 20 2 8 _Paper_analysis/vs_WTw_output/Matthews_script/Nanopolish/AllvsWTw_W0_polya_results.tsv ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.sam EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa 1 80

#renaming to get rid of the dot in the name
#mv _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_fullLength.start_sad_stop_pattern_count.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_fullLength_start_sad_stop_pattern_count.txt 

# Run the Matthews script 2. Amend prefix for correct folder
# - guidance: And now second script: name_transcripts_and_track_ssc_V2.pl prefix ssc_nt features_table.txt genome.fasta start_sad_stop_pattern_count.txt
perl Matthews_script/name_transcripts_and_track_ssc_V2.pl 2_AllvsWTw_W0_fullLength 10 EBV_annotations/EBV_annotations_paper/Features_table_pHB9_oriPMlu.txt EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/1_AllvsWTw_W0_fullLength.start_sad_stop_pattern_count.txt


mv 2_AllvsWTw_W0_fullLength_ssc.proteins_not_known.fasta _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.proteins_not_known.fasta
mv 2_AllvsWTw_W0_fullLength_ssc.proteins_known.fasta  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.proteins_known.fasta
cp -r 2_AllvsWTw_W0_fullLength_ssc _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/
rm -rf 2_AllvsWTw_W0_fullLength_ssc 
mv 2_AllvsWTw_W0_fullLength_ssc.combined_counts_and_feature_names.txt  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.combined_counts_and_feature_names.txt
mv 2_AllvsWTw_W0_fullLength_ssc.count_of_translated_features.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.count_of_translated_features.txt
mv 2_AllvsWTw_W0_fullLength_ssc.most_abundant_trans_per_orf.gff  _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.most_abundant_trans_per_orf.gff
mv 2_AllvsWTw_W0_fullLength_ssc.splice_acceptor_donor_usage.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.splice_acceptor_donor_usage.txt
mv 2_AllvsWTw_W0_fullLength_ssc.TSS_start_sad_polyA_count_list.txt _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/2_AllvsWTw_W0_fullLength_ssc.TSS_start_sad_polyA_count_list.txt

perl Matthews_script/all_transcripts_grouped_by_polya.pl ./_Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.sam 1 100 20 25 40 EBV_annotations/EBV_annotations_paper/MR11_oriPMlu_noATG.fa

mkdir _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/pA_SAM_full_length
mv -f polya_group_* _Paper_analysis/vs_WTw_output/Matthews_script/Script_out/pA_SAM_full_length

mkdir _Paper_analysis/vs_WTw_output/Single_samples
cp _Paper_analysis/vs_WTw_output/W0_SAM/W0_all_reads/AllvsWTw_W0_sort.sam  _Paper_analysis/vs_WTw_output/Single_samples/AllvsWTw_W0_sort.sam
cp _Paper_analysis/vs_WTw_output/W0_SAM/W0_full_length/AllvsWTw_W0_fullLength_sort.sam  _Paper_analysis/vs_WTw_output/Single_samples/AllvsWTw_W0_fullLength_sort.sam

